summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorÖrjan Persson <orjan@spotify.com>2012-10-16 22:36:56 -0700
committerÖrjan Persson <orjan@spotify.com>2012-10-17 11:36:51 -0700
commit91e5619a585f3c94a3c6c536a5b40c772f64bf85 (patch)
tree58740adb1c60c2063c6ad3227f9bad6ec19ec5a7
parentc2ae9e09ca1f33ff1e13e629a0b2e6bdd19f83a9 (diff)
downloadzsh-91e5619a585f3c94a3c6c536a5b40c772f64bf85.tar.gz
zsh-91e5619a585f3c94a3c6c536a5b40c772f64bf85.tar.bz2
zsh-91e5619a585f3c94a3c6c536a5b40c772f64bf85.zip
Added last working directory plugin
Keeps track of the last changed directory. When a new shell is created, the last directory will be restored. Mimics how tabs works in many terminal emulators.
-rw-r--r--plugins/last-working-dir/last-working-dir.plugin.zsh23
1 files changed, 23 insertions, 0 deletions
diff --git a/plugins/last-working-dir/last-working-dir.plugin.zsh b/plugins/last-working-dir/last-working-dir.plugin.zsh
new file mode 100644
index 000000000..5b3121d11
--- /dev/null
+++ b/plugins/last-working-dir/last-working-dir.plugin.zsh
@@ -0,0 +1,23 @@
+#!/usr/bin/env zsh
+# Keeps track of the last used working directory and automatically jumps
+# into it for new shells.
+
+# Flag indicating if we've previously jumped to last directory.
+typeset -g ZSH_LAST_WORKING_DIRECTORY
+local cache_file="$ZSH/cache/last-working-dir"
+
+# Updates the last directory once directory is changed.
+function chpwd() {
+ echo "$PWD" > "$cache_file"
+}
+
+# Changes directory to the last working directory.
+function lwd() {
+ [[ ! -r "$cache_file" ]] || cd `cat "$cache_file"`
+}
+
+# Automatically jump to last working directory unless this isn't the first time
+# this plugin has been loaded.
+if [[ -z "$ZSH_LAST_WORKING_DIRECTORY" ]]; then
+ lwd 2>/dev/null && ZSH_LAST_WORKING_DIRECTORY=1 || true
+fi